#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

// ./a.out fileName pravaPristupa
int main(int argc, char** argv) {

    checkError(argc == 3, "args");

    // opcija 1
    // mode_t oldUmask = umask(0);

    // mode_t pravaPristupa = strtol(argv[2], NULL, 8);
    // int fd = open(argv[1], O_WRONLY | O_CREAT | O_EXCL, pravaPristupa);
    // checkError(fd != -1, "open");
    // close(fd);

    // umask(oldUmask);

    // opcija 2
    mode_t pravaPristupa = strtol(argv[2], NULL, 8);
    int fd = open(argv[1], O_RDONLY | O_CREAT, pravaPristupa);
    checkError(fd != -1, "open");
    close(fd);

    checkError(chmod(argv[1], pravaPristupa) != -1, "chnmod");

    exit(EXIT_SUCCESS);
}